import createActions from './createActions'

export default function createReducer (options) {
  const {setState, remove} = createActions(options.prefix)

  return function reducer (state = {}, action) {
    if (action.type !== setState.type && action.type !== remove.type) {
      return state
    }

    const {
      payload: {
        name,
        id,
        state: componentState
      }
    } = action

    const nextState = Object.assign({}, state)
    const tree = Object.assign({}, state[name])

    nextState[name] = tree

    if (action.type === setState.type) {
      tree[id] = Object.assign({}, tree[id], componentState)
    }

    if (action.type === remove.type) {
      delete tree[id]
      if (Object.keys(tree).length === 0) {
        delete nextState[name]
      }
    }

    return nextState
  }
}
